diff -ruN tarsnap-autoconf-1.0.33/lib/datastruct/patricia.c tarsnap-autoconf-1.0.34/lib/datastruct/patricia.c
--- tarsnap-autoconf-1.0.33/lib/datastruct/patricia.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/datastruct/patricia.c	2013-07-06 14:38:21.000000000 -0700
@@ -68,8 +68,8 @@
 };
 
 static struct pnode * node_alloc(uint8_t, const uint8_t *);
-static struct pnode * node_dup(struct pnode *, uint8_t, const uint8_t *);
-static int compare(struct pnode *, const uint8_t *, size_t, uint8_t *,
+static struct pnode * node_dup(const struct pnode *, uint8_t, const uint8_t *);
+static int compare(const struct pnode *, const uint8_t *, size_t, uint8_t *,
     uint8_t *);
 static int foreach_internal(struct pnode *,
     int(void *, uint8_t *, size_t, void *), void *, uint8_t *, size_t);
@@ -104,7 +104,7 @@
  * Create a duplicate of a node but with different slen and s[].
  */
 static struct pnode *
-node_dup(struct pnode * n0, uint8_t slen, const uint8_t * s)
+node_dup(const struct pnode * n0, uint8_t slen, const uint8_t * s)
 {
 	struct pnode *	n;
 
@@ -134,7 +134,7 @@
  * node).
  */
 static int
-compare(struct pnode * n, const uint8_t * key, size_t keylen,
+compare(const struct pnode * n, const uint8_t * key, size_t keylen,
     uint8_t * mlen, uint8_t * mask)
 {
 	size_t	i;
diff -ruN tarsnap-autoconf-1.0.33/lib/datastruct/rwhashtab.c tarsnap-autoconf-1.0.34/lib/datastruct/rwhashtab.c
--- tarsnap-autoconf-1.0.33/lib/datastruct/rwhashtab.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/datastruct/rwhashtab.c	2013-07-06 14:38:21.000000000 -0700
@@ -6,11 +6,13 @@
 #include <stdlib.h>
 #include <string.h>
 
-#include "crypto.h"
+#include "crypto_entropy.h"
 #include "ctassert.h"
 #include "sysendian.h"
 #include "warnp.h"
 
+#include "crypto.h"
+
 #include "rwhashtab.h"
 
 /*
diff -ruN tarsnap-autoconf-1.0.33/lib/keyfile/keyfile.c tarsnap-autoconf-1.0.34/lib/keyfile/keyfile.c
--- tarsnap-autoconf-1.0.33/lib/keyfile/keyfile.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/keyfile/keyfile.c	2013-07-06 14:38:21.000000000 -0700
@@ -132,7 +132,7 @@
 	if (asprintf(&pwprompt, "Please enter passphrase for keyfile %s",
 	    filename) == -1)
 		goto err0;
-	if (tarsnap_readpass(&passwd, pwprompt, NULL, 1)) {
+	if (readpass(&passwd, pwprompt, NULL, 1)) {
 		warnp("Error reading passphrase");
 		goto err1;
 	}
diff -ruN tarsnap-autoconf-1.0.33/lib/netpacket/netpacket_hmac.c tarsnap-autoconf-1.0.34/lib/netpacket/netpacket_hmac.c
--- tarsnap-autoconf-1.0.33/lib/netpacket/netpacket_hmac.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/netpacket/netpacket_hmac.c	2013-07-06 14:38:21.000000000 -0700
@@ -2,6 +2,8 @@
 
 #include <string.h>
 
+#include "crypto_verify_bytes.h"
+
 #include "crypto.h"
 
 #include "netpacket.h"
diff -ruN tarsnap-autoconf-1.0.33/lib/netpacket/netpacket_op.c tarsnap-autoconf-1.0.34/lib/netpacket/netpacket_op.c
--- tarsnap-autoconf-1.0.33/lib/netpacket/netpacket_op.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/netpacket/netpacket_op.c	2013-07-06 14:38:21.000000000 -0700
@@ -25,7 +25,7 @@
 #define MAXRECONNECTS	10
 
 /* As above, except the server doesn't seem to be around at all. */
-#define MAXRECONNECTS_AWOL	1
+#define MAXRECONNECTS_AWOL	3
 
 /* Time to wait between each attempt. */
 static int reconnect_wait[MAXRECONNECTS + 1] = {
diff -ruN tarsnap-autoconf-1.0.33/lib/netproto/netproto.c tarsnap-autoconf-1.0.34/lib/netproto/netproto.c
--- tarsnap-autoconf-1.0.33/lib/netproto/netproto.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/netproto/netproto.c	2013-07-06 14:38:21.000000000 -0700
@@ -3,7 +3,7 @@
 #include <errno.h>
 #include <stdlib.h>
 
-#include "network.h"
+#include "tsnetwork.h"
 #include "warnp.h"
 
 #include "netproto.h"
@@ -51,13 +51,13 @@
 }
 
 /**
- * netproto_open(fd):
- * Create and return a network protocol connection cookie for use on the
- * connected socket ${fd}.  Note that netproto_keyexchange() must be called
- * before _writepacket or _readpacket are called on the cookie.
+ * netproto_alloc(callback, cookie):
+ * Allocate a network protocol connection cookie.  If the connection is closed
+ * before netproto_setfd is called, netproto_close will call callback(cookie)
+ * in lieu of performing callback cancels on a socket.
  */
-NETPROTO_CONNECTION *
-netproto_open(int fd)
+struct netproto_connection_internal *
+netproto_alloc(int (* callback)(void *), void * cookie)
 {
 	struct netproto_connection_internal * C;
 
@@ -65,31 +65,53 @@
 	if ((C = malloc(sizeof(struct netproto_connection_internal))) == NULL)
 		goto err0;
 
-	/* We have a file descriptor, but we don't have keys yet. */
-	C->fd = fd;
-	C->keys = NULL;
+	/* Record connect-cancel callback and cookie. */
+	C->cancel = callback;
+	C->cookie = cookie;
 
-	/* We're not sleeping. */
+	/* We have no state yet. */
+	C->fd = -1;
+	C->keys = NULL;
 	C->sleepcookie.handle = -1;
-
-	/* No traffic yet. */
 	C->bytesin = C->bytesout = C->bytesqueued = 0;
-
-	/* The connection isn't broken. */
 	C->broken = 0;
+	C->Q = NULL;
+
+	/* Success! */
+	return (C);
+
+err0:
+	/* Failure! */
+	return (NULL);
+}
+
+/**
+ * netproto_setfd(C, fd):
+ * Set the network protocol connection cookie ${C} to use connected socket
+ * ${fd}.  This function must be called exactly once after netproto_alloc
+ * before calling any other functions aside from netproto_free.
+ */
+int
+netproto_setfd(struct netproto_connection_internal * C, int fd)
+{
+
+	/* The connect is no longer pending. */
+	C->cancel = NULL;
+	C->cookie = NULL;
+
+	/* We have a file descriptor. */
+	C->fd = fd;
 
 	/* Create a network layer write queue. */
 	if ((C->Q = network_writeq_init(fd)) == NULL)
-		goto err1;
+		goto err0;
 
 	/* Success! */
-	return (C);
+	return (0);
 
-err1:
-	free(C);
 err0:
 	/* Failure! */
-	return (NULL);
+	return (-1);
 }
 
 /**
@@ -174,7 +196,10 @@
 	int rc, rc2;
 
 	/* Cancel pending writes. */
-	rc = network_writeq_cancel(C->Q);
+	if (C->Q != NULL)
+		rc = network_writeq_cancel(C->Q);
+	else
+		rc = 0;
 
 	/*
 	 * Mark this connection as being broken.  The upstream caller should
@@ -184,9 +209,11 @@
 	C->broken = 1;
 
 	/* Cancel any in-progress read. */
-	rc2 = network_deregister(C->fd, NETWORK_OP_READ);
-	if (rc == 0)
-		rc = rc2;
+	if (C->fd != -1) {
+		rc2 = network_deregister(C->fd, NETWORK_OP_READ);
+		if (rc == 0)
+			rc = rc2;
+	}
 
 	/* Return success or the first nonzero callback value. */
 	return (rc);
@@ -201,25 +228,33 @@
 {
 	int rc, rc2;
 
-	/* Cancel any in-progress sleep. */
-	if (C->sleepcookie.handle != -1)
-		network_desleep(C->sleepcookie.handle);
+	/* If we were connecting, cancel that. */
+	if (C->cancel != NULL)
+		rc = (C->cancel)(C->cookie);
+	else
+		rc = 0;
 
 	/* Cancel pending writes. */
-	rc = network_writeq_cancel(C->Q);
+	if (C->Q != NULL) {
+		rc2 = network_writeq_cancel(C->Q);
+		rc = rc ? rc : rc2;
+	}
 
 	/* Free the write queue. */
-	network_writeq_free(C->Q);
+	if (C->Q != NULL)
+		network_writeq_free(C->Q);
 
 	/* Cancel any in-progress read. */
-	rc2 = network_deregister(C->fd, NETWORK_OP_READ);
-	rc = rc ? rc : rc2;
+	if (C->fd != -1) {
+		rc2 = network_deregister(C->fd, NETWORK_OP_READ);
+		rc = rc ? rc : rc2;
+	}
 
 	/* Free cryptographic keys, if any exist. */
 	crypto_session_free(C->keys);
 
 	/* Close the socket. */
-	while (close(C->fd)) {
+	while (C->fd != -1 && close(C->fd)) {
 		if (errno == ECONNRESET) {
 			/*
 			 * You can't dump me!  I'm dumping you!  We don't
diff -ruN tarsnap-autoconf-1.0.33/lib/netproto/netproto.h tarsnap-autoconf-1.0.34/lib/netproto/netproto.h
--- tarsnap-autoconf-1.0.33/lib/netproto/netproto.h	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/netproto/netproto.h	2013-07-06 14:38:21.000000000 -0700
@@ -3,7 +3,7 @@
 
 #include <stdint.h>
 
-#include "network.h"
+#include "tsnetwork.h"
 
 typedef struct netproto_connection_internal NETPROTO_CONNECTION;
 
diff -ruN tarsnap-autoconf-1.0.33/lib/netproto/netproto_connect.c tarsnap-autoconf-1.0.34/lib/netproto/netproto_connect.c
--- tarsnap-autoconf-1.0.33/lib/netproto/netproto_connect.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/netproto/netproto_connect.c	2013-07-06 14:38:21.000000000 -0700
@@ -3,59 +3,76 @@
 #include <sys/types.h>
 #include <sys/socket.h>
 
-#include <arpa/inet.h>
-#include <netinet/in.h>
-
-#include <netdb.h>
 #include <stdlib.h>
 #include <string.h>
 #include <time.h>
 
 #include "netproto_internal.h"
+#include "sock.h"
+#include "sock_util.h"
 #include "network.h"
 #include "warnp.h"
 
 #include "netproto.h"
 
 struct netproto_connect_cookie {
+	struct sock_addr ** sas;
 	char * useragent;
 	network_callback * callback;
 	void * cookie;
+	void * connect_cookie;
 	NETPROTO_CONNECTION * NC;
 };
 
-static network_callback callback_connect;
-static int dnslookup(const char *, struct sockaddr **, socklen_t *);
-
 static int
-callback_connect(void * cookie, int status)
+callback_connect(void * cookie, int s)
 {
 	struct netproto_connect_cookie * C = cookie;
 	int rc;
 
+	/* The connect is no longer pending. */
+	C->connect_cookie = NULL;
+
 	/* Did the connection attempt fail? */
-	if (status != NETWORK_STATUS_OK)
-		goto failed;
+	if (s == -1) {
+		/*
+		 * Call the upstream callback.  Upon being informed that the
+		 * connect has failed, the upstream code is responsible for
+		 * calling netproto_close, which (since we haven't called
+		 * netproto_setfd yet) will call into callback_cancel and let
+		 * us clean up.
+		 */
+		return ((C->callback)(C->cookie, NETWORK_STATUS_CONNERR));
+	}
+
+	/* Inform the netproto code that we have a socket. */
+	if (netproto_setfd(C->NC, s))
+		goto err2;
 
 	/* Perform key exchange. */
-	if (netproto_keyexchange(C->NC, C->useragent,
-	    C->callback, C->cookie)) {
-		status = NETWORK_STATUS_ERR;
-		goto failed;
-	}
+	if (netproto_keyexchange(C->NC, C->useragent, C->callback, C->cookie))
+		goto err1;
 
 	/* Free the cookie. */
+	sock_addr_freelist(C->sas);
 	free(C->useragent);
 	free(C);
 
 	/* Success! */
 	return (0);
 
-failed:
+err2:
+	/* Drop the socket since we can't use it properly. */
+	close(s);
+err1:
 	/* Call the upstream callback. */
-	rc = (C->callback)(C->cookie, status);
+	rc = (C->callback)(C->cookie, NETWORK_STATUS_ERR);
 
-	/* Free the cookie. */
+	/*
+	 * We've called netproto_setfd, so callback_cancel won't happen; we
+	 * are responsible for cleaning up after ourselves.
+	 */
+	sock_addr_freelist(C->sas);
 	free(C->useragent);
 	free(C);
 
@@ -63,99 +80,34 @@
 	return (rc);
 }
 
-#ifdef HAVE_GETADDRINFO
 static int
-dnslookup(const char * sname, struct sockaddr ** addr, socklen_t * addrlen)
+callback_cancel(void * cookie)
 {
-	struct addrinfo hints;
-	struct addrinfo * res;
-	int error;
-
-	/* Do the DNS lookup. */
-	memset(&hints, 0, sizeof(hints));
-	hints.ai_family = AF_INET;
-	hints.ai_socktype = SOCK_STREAM;
-	hints.ai_protocol = IPPROTO_TCP;
-#ifdef AI_NUMERICSERV
-	/**
-	 * XXX Portability
-	 * XXX POSIX states that AI_NUMERICSERV should be defined in netdb.h,
-	 * XXX but some operating systems don't provide it.  The flag isn't
-	 * XXX really necessary anyway, since getaddrinfo should interpret
-	 * XXX "9279" as 'a string specifying a decimal port number'; but
-	 * XXX passing the flag (on operating systems which provide it) might
-	 * XXX avoid waiting for a name resolution service (e.g., NIS+) to
-	 * XXX be invoked.
-	 */
-	hints.ai_flags = AI_NUMERICSERV;
-#endif
-	if ((error = getaddrinfo(sname, "9279",
-	    &hints, &res)) != 0) {
-		warn0("Error looking up %s: %s", sname, gai_strerror(error));
-		goto err0;
-	}
-	if (res == NULL) {
-		warn0("Cannot look up %s", sname);
-		goto err0;
-	}
-
-	/* Create a copy of the structure. */
-	if ((*addr = malloc(res->ai_addrlen)) == NULL)
-		goto err0;
-	memcpy(*addr, res->ai_addr, res->ai_addrlen);
-	*addrlen = res->ai_addrlen;
-
-	/* Free the returned list of addresses. */
-	freeaddrinfo(res);
-
-	/* Success! */
-	return (0);
-
-err0:
-	/* Failure! */
-	return (-1);
-}
-#else
-static int
-dnslookup(const char * sname, struct sockaddr ** addr, socklen_t * addrlen)
-{
-	struct hostent * hp;
-	struct sockaddr_in sin;
-
-	if ((hp = gethostbyname(sname)) == NULL) {
-		warn0("Error looking up %s", sname);
-		goto err0;
-	}
+	struct netproto_connect_cookie * C = cookie;
+	int rc;
 
-	/* Construct a struct sockaddr_in. */
-	bzero(&sin, sizeof(struct sockaddr_in));
-	sin.sin_family = AF_INET;
-	sin.sin_port = htons(9279);
-	memcpy(&sin.sin_addr, hp->h_addr, hp->h_length);
+	/* Cancel the connection attempt if still pending. */
+	if (C->connect_cookie != NULL)
+		network_connect_cancel(C->connect_cookie);
 
-	/* Make a copy of this to return. */
-	if ((*addr = malloc(sizeof(struct sockaddr_in))) == NULL)
-		goto err0;
-	memcpy(*addr, &sin, sizeof(struct sockaddr_in));
-	*addrlen = sizeof(struct sockaddr_in);
+	/* We were cancelled. */
+	rc = (C->callback)(C->cookie, NETWORK_STATUS_CANCEL);
 
-	/* Success! */
-	return (0);
+	/* Free our cookie. */
+	sock_addr_freelist(C->sas);
+	free(C->useragent);
+	free(C);
 
-err0:
-	/* Failure! */
-	return (-1);
+	/* Return value from user callback. */
+	return (rc);
 }
-#endif
 
-static void
-getserveraddr(struct sockaddr ** addr, socklen_t * addrlen)
+static struct sock_addr **
+getserveraddr(void)
 {
-	static struct sockaddr * srv_addr = NULL;
-	static socklen_t srv_addrlen = 0;
+	static struct sock_addr ** srv_addr = NULL;
 	static time_t srv_time = (time_t)(-1);
-	struct sockaddr * tmp_addr;
-	socklen_t tmp_addrlen;
+	struct sock_addr ** tmp_addr;
 	time_t tmp_time;
 
 	/*
@@ -164,13 +116,12 @@
 	 */
 	tmp_time = time(NULL);
 	if ((srv_time == (time_t)(-1)) || (tmp_time > srv_time + 60)) {
-		if (dnslookup(TSSERVER "-server.tarsnap.com",
-		    &tmp_addr, &tmp_addrlen)) {
+		tmp_addr = sock_resolve(TSSERVER "-server.tarsnap.com:9279");
+		if (tmp_addr == NULL) {
 			if (srv_addr != NULL)
 				warn0("Using cached DNS lookup");
 			else
 				warn0("Cannot obtain server address");
-			tmp_addr = NULL;
 		}
 	} else {
 		tmp_addr = NULL;
@@ -178,15 +129,13 @@
 
 	/* If we have a new lookup, update the cache. */
 	if (tmp_addr != NULL) {
-		free(srv_addr);
+		sock_addr_freelist(srv_addr);
 		srv_addr = tmp_addr;
-		srv_addrlen = tmp_addrlen;
 		srv_time = tmp_time;
 	}
 
-	/* Return the cached value. */
-	*addr = srv_addr;
-	*addrlen = srv_addrlen;
+	/* Return a duplicate of the cached value. */
+	return (sock_addr_duplist(srv_addr));
 }
 
 /**
@@ -200,56 +149,44 @@
     network_callback * callback, void * cookie)
 {
 	struct netproto_connect_cookie * C;
-	int s;
-	NETPROTO_CONNECTION * NC;
-	struct sockaddr * addr;
-	socklen_t addrlen;
 	struct timeval timeo;
 
-	/* Create a network socket. */
-	if ((s = socket(PF_INET, SOCK_STREAM, 0)) == -1) {
-		warnp("socket()");
-		goto err0;
-	}
-
-	/* Wrap the socket into a protocol-layer cookie. */
-	if ((NC = netproto_open(s)) == NULL) {
-		close(s);
-		goto err0;
-	}
-
 	/* Create a cookie to be passed to callback_connect. */
 	if ((C = malloc(sizeof(struct netproto_connect_cookie))) == NULL)
-		goto err1;
+		goto err0;
 	if ((C->useragent = strdup(useragent)) == NULL)
-		goto err2;
+		goto err1;
 	C->callback = callback;
 	C->cookie = cookie;
-	C->NC = NC;
 
 	/* Look up the server's IP address. */
-	getserveraddr(&addr, &addrlen);
-	if (addr == NULL)
-		goto err3;
+	if ((C->sas = getserveraddr())== NULL)
+		goto err2;
 
-	/* Try to connect to server within 5 seconds. */
+	/* Try to connect to server, waiting up to 5 seconds per address. */
 	timeo.tv_sec = 5;
 	timeo.tv_usec = 0;
-	if (network_connect(s, addr, addrlen,
-	    &timeo, callback_connect, C)) {
+	if ((C->connect_cookie = network_connect_timeo(C->sas, &timeo,
+	    callback_connect, C)) == NULL) {
 		netproto_printerr(NETWORK_STATUS_CONNERR);
 		goto err3;
 	}
 
+	/* Create a network protocol connection cookie. */
+	if ((C->NC = netproto_alloc(callback_cancel, C)) == NULL)
+		goto err4;
+
 	/* Success! */
-	return (NC);
+	return (C->NC);
 
+err4:
+	network_connect_cancel(C->connect_cookie);
 err3:
-	free(C->useragent);
+	sock_addr_freelist(C->sas);
 err2:
-	free(C);
+	free(C->useragent);
 err1:
-	netproto_close(NC);
+	free(C);
 err0:
 	/* Failure! */
 	return (NULL);
diff -ruN tarsnap-autoconf-1.0.33/lib/netproto/netproto_internal.h tarsnap-autoconf-1.0.34/lib/netproto/netproto_internal.h
--- tarsnap-autoconf-1.0.33/lib/netproto/netproto_internal.h	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/netproto/netproto_internal.h	2013-07-06 14:38:21.000000000 -0700
@@ -4,9 +4,11 @@
 #include <stdint.h>
 
 #include "crypto.h"
-#include "network.h"
+#include "tsnetwork.h"
 
 struct netproto_connection_internal {
+	int (*cancel)(void *);
+	void * cookie;
 	int fd;
 	NETWORK_WRITEQ * Q;
 	CRYPTO_SESSION * keys;
@@ -22,6 +24,22 @@
 };
 
 /**
+ * netproto_alloc(callback, cookie):
+ * Allocate a network protocol connection cookie.  If the connection is closed
+ * before netproto_setfd is called, netproto_close will call callback(cookie)
+ * in lieu of performing callback cancels on a socket.
+ */
+struct netproto_connection_internal * netproto_alloc(int (*)(void *), void *);
+
+/**
+ * netproto_setfd(C, fd):
+ * Set the network protocol connection cookie ${C} to use connected socket
+ * ${fd}.  This function must be called exactly once after netproto_alloc
+ * before calling any other functions aside from netproto_free.
+ */
+int netproto_setfd(struct netproto_connection_internal *, int);
+
+/**
  * netproto_open(fd):
  * Create and return a network protocol connection cookie for use on the
  * connected socket ${fd}.  Note that netproto_keyexchange() must be called
diff -ruN tarsnap-autoconf-1.0.33/lib/netproto/netproto_keyexchange.c tarsnap-autoconf-1.0.34/lib/netproto/netproto_keyexchange.c
--- tarsnap-autoconf-1.0.33/lib/netproto/netproto_keyexchange.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/netproto/netproto_keyexchange.c	2013-07-06 14:38:21.000000000 -0700
@@ -4,12 +4,14 @@
 #include <stdlib.h>
 #include <string.h>
 
-#include "crypto.h"
+#include "crypto_dh.h"
 #include "ctassert.h"
-#include "netproto_internal.h"
-#include "network.h"
 #include "warnp.h"
 
+#include "crypto.h"
+#include "netproto_internal.h"
+#include "tsnetwork.h"
+
 #include "netproto.h"
 
 struct keyexchange_internal {
@@ -152,7 +154,7 @@
 	KC->C->bytesout += 1;
 
 	/* Data was sent.  Read the server protocol version. */
-	if (network_read(KC->C->fd, &KC->serverproto, 1, &KC->timeout,
+	if (tsnetwork_read(KC->C->fd, &KC->serverproto, 1, &KC->timeout,
 	    &KC->timeout, proto_received, KC))
 		goto err2;
 
@@ -260,7 +262,7 @@
 	KC->C->bytesout += KC->useragentlen;
 
 	/* Data was sent.  Read the server crypto parameters. */
-	if (network_read(KC->C->fd, KC->serverparams,
+	if (tsnetwork_read(KC->C->fd, KC->serverparams,
 	    CRYPTO_DH_PUBLEN + 256 + 32, &KC->timeout, &KC->timeout,
 	    dh_received, KC))
 		goto err2;
@@ -417,7 +419,7 @@
 	KC->C->bytesout += 32;
 
 	/* Client proof was sent.  Read the server proof. */
-	if (network_read(KC->C->fd, KC->serverproof, 32, &KC->timeout,
+	if (tsnetwork_read(KC->C->fd, KC->serverproof, 32, &KC->timeout,
 	    &KC->timeout, proof_received, KC))
 		goto err2;
 
diff -ruN tarsnap-autoconf-1.0.33/lib/netproto/netproto_packet.c tarsnap-autoconf-1.0.34/lib/netproto/netproto_packet.c
--- tarsnap-autoconf-1.0.33/lib/netproto/netproto_packet.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/netproto/netproto_packet.c	2013-07-06 14:38:21.000000000 -0700
@@ -7,12 +7,14 @@
 #include <stdlib.h>
 #include <string.h>
 
-#include "crypto.h"
-#include "netproto_internal.h"
-#include "network.h"
+#include "crypto_verify_bytes.h"
 #include "sysendian.h"
 #include "warnp.h"
 
+#include "crypto.h"
+#include "netproto_internal.h"
+#include "tsnetwork.h"
+
 #include "netproto.h"
 
 /**
@@ -132,7 +134,7 @@
 	to0.tv_sec = 60;
 	to1.tv_sec = 300;
 	to0.tv_usec = to1.tv_usec = 0;
-	if (network_read(RC->C->fd, RC->buf, RC->len, &to0, &to1,
+	if (tsnetwork_read(RC->C->fd, RC->buf, RC->len, &to0, &to1,
 	    data_received, RC))
 		goto err2;
 
@@ -323,7 +325,7 @@
 	to0.tv_sec = 60;
 	to1.tv_sec = 120;
 	to0.tv_usec = to1.tv_usec = 0;
-	if (network_read(C->fd, RC->header, 69, &to0, &to1,
+	if (tsnetwork_read(C->fd, RC->header, 69, &to0, &to1,
 	    header_received, RC))
 		goto err1;
 
diff -ruN tarsnap-autoconf-1.0.33/lib/network/tsnetwork.h tarsnap-autoconf-1.0.34/lib/network/tsnetwork.h
--- tarsnap-autoconf-1.0.33/lib/network/tsnetwork.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/lib/network/tsnetwork.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,168 @@
+#ifndef _TSNETWORK_H_
+#define _TSNETWORK_H_
+
+#include <sys/types.h>
+#include <sys/select.h>
+#include <sys/socket.h>
+
+#include <stdint.h>
+
+typedef struct network_writeq_internal NETWORK_WRITEQ;
+typedef int network_callback(void *, int);
+
+/* "op" parameters to network_register. */
+#define	NETWORK_OP_READ		0
+#define	NETWORK_OP_WRITE	1
+
+/* callback status values. */
+#define NETWORK_STATUS_CONNERR	(-2)	/* Error connecting to server. */
+#define NETWORK_STATUS_ERR	(-1)	/* Error from recv/send. */
+#define NETWORK_STATUS_OK	0	/* Success. */
+#define NETWORK_STATUS_TIMEOUT	1	/* Timeout. */
+#define NETWORK_STATUS_NODATA	2	/* Timeout with empty buffer. */
+#define NETWORK_STATUS_CTIMEOUT	3	/* Timeout connecting to server. */
+#define NETWORK_STATUS_CLOSED	4	/* Connection was closed. */
+#define NETWORK_STATUS_CANCEL	5	/* Operation cancelled. */
+#define NETWORK_STATUS_ZEROBYTE	6	/* Zero-byte write via writeq. */
+#define NETWORK_STATUS_MAX	6
+
+/**
+ * network_bwlimit(down, up):
+ * Set the bandwidth rate limit to ${down} bytes per second of read bandwidth
+ * and ${up} bytes per second of write bandwidth.  The values ${down} and
+ * ${up} must be between 8000 and 10^9.
+ */
+void network_bwlimit(double, double);
+
+/**
+ * network_register(fd, op, timeo, callback, cookie):
+ * Register a callback to be performed by network_select when file descriptor
+ * ${fd} is ready for operation ${op}, or once the timeout has expired.
+ */
+int network_register(int, int, struct timeval *, network_callback *, void *);
+
+/**
+ * network_deregister(fd, op):
+ * Deregister the callback, if any, for operation ${op} on descriptor ${fd}.
+ * The callback will be called with a status of NETWORK_STATUS_CANCEL.
+ */
+int network_deregister(int, int);
+
+/**
+ * network_sleep(timeo, callback, cookie):
+ * Register a callback to be performed by network_select once the specified
+ * timeout has expired.  Return a handle which can be passed to
+ * network_desleep().
+ */
+int network_sleep(struct timeval *, network_callback *, void *);
+
+/**
+ * network_desleep(handle):
+ * Deregister the callback associated with the provided handle.  The
+ * callback will be called with a status of NETWORK_STATUS_CANCEL.
+ */
+int network_desleep(int);
+
+/**
+ * network_select(blocking):
+ * Call select(2) on file descriptors provided via network_register and make
+ * callbacks as appropriate (including timeouts).  Callbacks are deregistered
+ * before being performed.  If ${blocking} is non-zero, allow select(2) to
+ * block waiting for descriptors and timeouts.  Stop performing callbacks and
+ * return the first non-zero value returned by a callback if one occurs.
+ */
+int network_select(int);
+
+/**
+ * network_spin(done):
+ * Repeatedly call network_select until either an error occurs or the value
+ * pointed to by ${done} is non-zero.
+ */
+int network_spin(int *);
+
+/**
+ * tsnetwork_connect(s, addr, addrlen, timeout, callback, cookie):
+ * Connect the specified socket to the specified address, and call the
+ * specified callback when connected or the connection attempt has failed.
+ */
+int tsnetwork_connect(int, const struct sockaddr *, socklen_t,
+    struct timeval *, network_callback *, void *);
+
+/**
+ * tsnetwork_read(fd, buf, buflen, to0, to1, callback, cookie):
+ * Asynchronously fill the provided buffer with data from ${fd}, and call
+ * callback(cookie, status) where status is a NETWORK_STATUS_* value.  Time
+ * out if no data can be read for a period of time to0, or if the complete
+ * buffer has not been read after time to1.  Note that ${buflen} must be
+ * non-zero, since otherwise deadlock would result.
+ */
+int tsnetwork_read(int, uint8_t *, size_t, struct timeval *, struct timeval *,
+    network_callback *, void *);
+
+/**
+ * tsnetwork_write(fd, buf, buflen, to0, to1, callback, cookie):
+ * Asynchronously write data from the provided buffer to ${fd}, and call
+ * callback(cookie, status) where status is a NETWORK_STATUS_* value.  Time
+ * out if no data can be written for a period of time to0, or if the complete
+ * buffer has not been written after time to1.  If ${buflen} is zero, the
+ * callback will be invoked with a status of NETWORK_STATUS_CLOSED, even if
+ * the connection is still open.
+ */
+int tsnetwork_write(int, const uint8_t *, size_t, struct timeval *,
+    struct timeval *, network_callback *, void *);
+
+/**
+ * network_writeq_init(fd):
+ * Construct a queue to be used for writing data to ${fd}.
+ */
+NETWORK_WRITEQ * network_writeq_init(int);
+
+/**
+ * _network_writeq_add(Q, buf, buflen, timeo, callback, cookie, abstimeo):
+ * Add a buffer write to the specified write queue.  The callback function
+ * will be called when the write is finished, fails, or is cancelled.
+ * If ${abstimeo} is zero, the timeout is relative to when the buffer in
+ * question starts to be written (i.e., when the previous buffered write
+ * finishes); otherwise, the timeout is relative to the present time.  If
+ * ${buflen} is zero, the callback will be performed, at the appropriate
+ * point, with a status of NETWORK_STATUS_ZEROBYTE.
+ */
+int _network_writeq_add(NETWORK_WRITEQ *, const uint8_t *, size_t,
+    struct timeval *, network_callback *, void *, int);
+#define network_writeq_add(Q, buf, buflen, timeo, callback, cookie)	\
+	_network_writeq_add(Q, buf, buflen, timeo, callback, cookie, 0)
+#define network_writeq_add_abs(Q, buf, buflen, timeo, callback, cookie)	\
+	_network_writeq_add(Q, buf, buflen, timeo, callback, cookie, 1)
+
+/**
+ * network_writeq_cancel(Q):
+ * Cancel all queued writes, including any partially completed writes.  Note
+ * that since this leaves the connection in an indeterminate state (there is
+ * no way to know how much data from the currently in-progress write was
+ * written) this should probably only be used prior to closing a connection.
+ * The callbacks for each pending write will be called with a status of
+ * NETWORK_STATUS_DEQUEUE, and network_writeq_cancel will return the first
+ * non-zero value returned by a callback.
+ */
+int network_writeq_cancel(NETWORK_WRITEQ *);
+
+/**
+ * network_writeq_free(Q):
+ * Free the specified write queue.  If there might be any pending writes,
+ * network_writeq_cancel should be called first.
+ */
+void network_writeq_free(NETWORK_WRITEQ *);
+
+/**
+ * network_getselectstats(N, mu, va, max):
+ * Return statistics on the time between select(2) calls.
+ */
+void network_getselectstats(double *, double *, double *, double *);
+
+/**
+ * network_fini(void):
+ * Free resources associated with the network subsystem.
+ */
+void network_fini(void);
+
+#endif /* !_TSNETWORK_H_ */
